/*
 * This file is part of PySide: Python for Qt
 *
 * Copyright (C) 2009-2010 Nokia Corporation and/or its subsidiary(-ies).
 *
 * Contact: PySide team <contact@pyside.org>
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public License
 * version 2.1 as published by the Free Software Foundation.
 *
 * This library is distributed in the hope that it will be useful, but
 * WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU
 * Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public
 * License along with this library; if not, write to the Free Software
 * Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA
 * 02110-1301 USA
 *
 */


//workaround to access protected functions
#define protected public

// default includes
#include <shiboken.h>
#include <pysidesignal.h>
#include <pysideproperty.h>
#include <pyside.h>
#include <typeresolver.h>
#include <typeinfo>
#include "pyside_qtgui_python.h"

#include "qabstracttextdocumentlayout_paintcontext_wrapper.h"

// Extra includes



// Target ---------------------------------------------------------

extern "C" {
static int
Sbk_QAbstractTextDocumentLayout_PaintContext_Init(PyObject* self, PyObject* args, PyObject* kwds)
{
    if (Shiboken::Object::isUserType(self) && !Shiboken::ObjectType::canCallConstructor(self->ob_type, Shiboken::SbkType<QAbstractTextDocumentLayout::PaintContext >()))
        return -1;

    QAbstractTextDocumentLayout::PaintContext* cptr = 0;
    int overloadId = -1;
    SbkObject* sbkSelf = reinterpret_cast<SbkObject*>(self);


    int numArgs = PyTuple_GET_SIZE(args);
    PyObject* pyargs[] = {0};

    // invalid argument lengths


    if (!PyArg_UnpackTuple(args, "PaintContext", 0, 1, &(pyargs[0])))
        return -1;

    // Overloaded function decisor
    // 0: PaintContext()
    // 1: PaintContext(QAbstractTextDocumentLayout::PaintContext)
    if (numArgs == 0) {
        overloadId = 0; // PaintContext()
    } else if (numArgs == 1 && Shiboken::Converter< ::QAbstractTextDocumentLayout::PaintContext >::isConvertible(pyargs[0])) {
        overloadId = 1; // PaintContext(QAbstractTextDocumentLayout::PaintContext)
    }

    // Function signature not found.
    if (overloadId == -1) goto Sbk_QAbstractTextDocumentLayout_PaintContext_Init_TypeError;

    // Call function/method
    {
        switch (overloadId) {
            case 0: // PaintContext()
            {

                if(!PyErr_Occurred()) {
                    // PaintContext()
                    PyThreadState* _save = PyEval_SaveThread(); // Py_BEGIN_ALLOW_THREADS
                    cptr = new QAbstractTextDocumentLayout::PaintContext();
                    PyEval_RestoreThread(_save); // Py_END_ALLOW_THREADS
                }
                break;
            }
            case 1: // PaintContext(QAbstractTextDocumentLayout::PaintContext)
            {
                if (!Shiboken::Object::isValid(pyargs[0]))
                    return -1;
                QAbstractTextDocumentLayout::PaintContext cppArg0 = Shiboken::Converter<QAbstractTextDocumentLayout::PaintContext >::toCpp(pyargs[0]);

                if(!PyErr_Occurred()) {
                    // PaintContext(QAbstractTextDocumentLayout::PaintContext)
                    PyThreadState* _save = PyEval_SaveThread(); // Py_BEGIN_ALLOW_THREADS
                    cptr = new QAbstractTextDocumentLayout::PaintContext(cppArg0);
                    PyEval_RestoreThread(_save); // Py_END_ALLOW_THREADS
                }
                break;
            }
        }
    }

    if (PyErr_Occurred() || !Shiboken::Object::setCppPointer(sbkSelf, Shiboken::SbkType<QAbstractTextDocumentLayout::PaintContext >(), cptr)) {
        delete cptr;
        return -1;
    }
    if (!cptr) goto Sbk_QAbstractTextDocumentLayout_PaintContext_Init_TypeError;

    Shiboken::Object::setValidCpp(sbkSelf, true);
    Shiboken::BindingManager::instance().registerWrapper(sbkSelf, cptr);


    return 1;

    Sbk_QAbstractTextDocumentLayout_PaintContext_Init_TypeError:
        const char* overloads[] = {"", "PySide.QtGui.QAbstractTextDocumentLayout::PaintContext", 0};
        Shiboken::setErrorAboutWrongArguments(args, "PySide.QtGui.PaintContext", overloads);
        return -1;
}

static PyObject *Sbk_QAbstractTextDocumentLayout_PaintContext___copy__(PyObject *self)
{
        QAbstractTextDocumentLayout::PaintContext* cppSelf = 0;
        if (!Shiboken::Object::isValid(self))
            return 0;
        cppSelf = Shiboken::Converter<QAbstractTextDocumentLayout::PaintContext*>::toCpp(self);
        PyObject* pyResult = 0;
        QAbstractTextDocumentLayout::PaintContext* copy = new QAbstractTextDocumentLayout::PaintContext(*cppSelf);
        pyResult = Shiboken::Converter<QAbstractTextDocumentLayout::PaintContext*>::toPython(copy);
        Shiboken::Object::getOwnership(pyResult);

        if (PyErr_Occurred() || !pyResult) {
            Py_XDECREF(pyResult);
            return 0;
        }
        return pyResult;
}

static PyMethodDef Sbk_QAbstractTextDocumentLayout_PaintContext_methods[] = {

    {"__copy__", (PyCFunction)Sbk_QAbstractTextDocumentLayout_PaintContext___copy__, METH_NOARGS},
    {0} // Sentinel
};

static PyObject* Sbk_QAbstractTextDocumentLayout_PaintContext_get_palette(PyObject* self, void*)
{
    PyObject* val = Shiboken::createWrapper(&Shiboken::Converter< QAbstractTextDocumentLayout::PaintContext* >::toCpp(self)->palette);
    Shiboken::Object::releaseOwnership(val);
    return val;
}

static int Sbk_QAbstractTextDocumentLayout_PaintContext_set_palette(PyObject* self, PyObject* value, void*)
{
    if (value == 0) {
        PyErr_SetString(PyExc_TypeError, "'palette' may not be deleted");
        return -1;
    }
    if (!Shiboken::Converter< ::QPalette >::isConvertible(value)) {
        PyErr_SetString(PyExc_TypeError, "wrong type attributed to 'palette', 'QPalette' or convertible type expected");
        return -1;
    }

    Shiboken::Converter< QAbstractTextDocumentLayout::PaintContext* >::toCpp(self)->palette = Shiboken::Converter< ::QPalette >::toCpp(value);

    return 0;
}

static PyObject* Sbk_QAbstractTextDocumentLayout_PaintContext_get_cursorPosition(PyObject* self, void*)
{
    PyObject* val = Shiboken::Converter< int >::toPython( Shiboken::Converter< QAbstractTextDocumentLayout::PaintContext* >::toCpp(self)->cursorPosition);
    return val;
}

static int Sbk_QAbstractTextDocumentLayout_PaintContext_set_cursorPosition(PyObject* self, PyObject* value, void*)
{
    if (value == 0) {
        PyErr_SetString(PyExc_TypeError, "'cursorPosition' may not be deleted");
        return -1;
    }
    if (!SbkNumber_Check(value)) {
        PyErr_SetString(PyExc_TypeError, "wrong type attributed to 'cursorPosition', 'int' or convertible type expected");
        return -1;
    }

    Shiboken::Converter< QAbstractTextDocumentLayout::PaintContext* >::toCpp(self)->cursorPosition = Shiboken::Converter< int >::toCpp(value);

    return 0;
}

static PyObject* Sbk_QAbstractTextDocumentLayout_PaintContext_get_clip(PyObject* self, void*)
{
    PyObject* val = Shiboken::createWrapper(&Shiboken::Converter< QAbstractTextDocumentLayout::PaintContext* >::toCpp(self)->clip);
    Shiboken::Object::releaseOwnership(val);
    return val;
}

static int Sbk_QAbstractTextDocumentLayout_PaintContext_set_clip(PyObject* self, PyObject* value, void*)
{
    if (value == 0) {
        PyErr_SetString(PyExc_TypeError, "'clip' may not be deleted");
        return -1;
    }
    if (!Shiboken::Converter< ::QRectF >::isConvertible(value)) {
        PyErr_SetString(PyExc_TypeError, "wrong type attributed to 'clip', 'QRectF' or convertible type expected");
        return -1;
    }

    Shiboken::Converter< QAbstractTextDocumentLayout::PaintContext* >::toCpp(self)->clip = Shiboken::Converter< ::QRectF >::toCpp(value);

    return 0;
}

// Getters and Setters for PaintContext
static PyGetSetDef Sbk_QAbstractTextDocumentLayout_PaintContext_getsetlist[] = {
    {const_cast<char*>("palette"), Sbk_QAbstractTextDocumentLayout_PaintContext_get_palette, Sbk_QAbstractTextDocumentLayout_PaintContext_set_palette},
    {const_cast<char*>("cursorPosition"), Sbk_QAbstractTextDocumentLayout_PaintContext_get_cursorPosition, Sbk_QAbstractTextDocumentLayout_PaintContext_set_cursorPosition},
    {const_cast<char*>("clip"), Sbk_QAbstractTextDocumentLayout_PaintContext_get_clip, Sbk_QAbstractTextDocumentLayout_PaintContext_set_clip},
    {0}  // Sentinel
};

} // extern "C"

// Class Definition -----------------------------------------------
extern "C" {
static SbkObjectType Sbk_QAbstractTextDocumentLayout_PaintContext_Type = { { {
    PyObject_HEAD_INIT(&SbkObjectType_Type)
    /*ob_size*/             0,
    /*tp_name*/             "PySide.QtGui.QAbstractTextDocumentLayout.PaintContext",
    /*tp_basicsize*/        sizeof(SbkObject),
    /*tp_itemsize*/         0,
    /*tp_dealloc*/          &SbkDeallocWrapper,
    /*tp_print*/            0,
    /*tp_getattr*/          0,
    /*tp_setattr*/          0,
    /*tp_compare*/          0,
    /*tp_repr*/             0,
    /*tp_as_number*/        0,
    /*tp_as_sequence*/      0,
    /*tp_as_mapping*/       0,
    /*tp_hash*/             0,
    /*tp_call*/             0,
    /*tp_str*/              0,
    /*tp_getattro*/         0,
    /*tp_setattro*/         0,
    /*tp_as_buffer*/        0,
    /*tp_flags*/            Py_TPFLAGS_DEFAULT|Py_TPFLAGS_BASETYPE|Py_TPFLAGS_CHECKTYPES,
    /*tp_doc*/              0,
    /*tp_traverse*/         0,
    /*tp_clear*/            0,
    /*tp_richcompare*/      0,
    /*tp_weaklistoffset*/   0,
    /*tp_iter*/             0,
    /*tp_iternext*/         0,
    /*tp_methods*/          Sbk_QAbstractTextDocumentLayout_PaintContext_methods,
    /*tp_members*/          0,
    /*tp_getset*/           Sbk_QAbstractTextDocumentLayout_PaintContext_getsetlist,
    /*tp_base*/             reinterpret_cast<PyTypeObject*>(&SbkObject_Type),
    /*tp_dict*/             0,
    /*tp_descr_get*/        0,
    /*tp_descr_set*/        0,
    /*tp_dictoffset*/       0,
    /*tp_init*/             Sbk_QAbstractTextDocumentLayout_PaintContext_Init,
    /*tp_alloc*/            0,
    /*tp_new*/              SbkObjectTpNew,
    /*tp_free*/             0,
    /*tp_is_gc*/            0,
    /*tp_bases*/            0,
    /*tp_mro*/              0,
    /*tp_cache*/            0,
    /*tp_subclasses*/       0,
    /*tp_weaklist*/         0
}, },
    /*priv_data*/           0
};
} //extern


void init_QAbstractTextDocumentLayout_PaintContext(PyObject* module)
{
    SbkPySide_QtGuiTypes[SBK_QABSTRACTTEXTDOCUMENTLAYOUT_PAINTCONTEXT_IDX] = reinterpret_cast<PyTypeObject*>(&Sbk_QAbstractTextDocumentLayout_PaintContext_Type);

    Shiboken::ObjectType::initPrivateData(&Sbk_QAbstractTextDocumentLayout_PaintContext_Type);
    Shiboken::ObjectType::setDestructorFunction(&Sbk_QAbstractTextDocumentLayout_PaintContext_Type, &Shiboken::callCppDestructor<QAbstractTextDocumentLayout::PaintContext >);
    if (PyType_Ready((PyTypeObject*)&Sbk_QAbstractTextDocumentLayout_PaintContext_Type) < 0)
        return;

    Shiboken::ObjectType::setOriginalName(&Sbk_QAbstractTextDocumentLayout_PaintContext_Type, "QAbstractTextDocumentLayout::PaintContext");
    PyDict_SetItemString(module,"PaintContext", (PyObject*)&Sbk_QAbstractTextDocumentLayout_PaintContext_Type);

    Shiboken::TypeResolver::createValueTypeResolver<QAbstractTextDocumentLayout::PaintContext >("QAbstractTextDocumentLayout::PaintContext");
    Shiboken::TypeResolver::createObjectTypeResolver<QAbstractTextDocumentLayout::PaintContext >("QAbstractTextDocumentLayout::PaintContext*");
    Shiboken::TypeResolver::createValueTypeResolver<QAbstractTextDocumentLayout::PaintContext >(typeid(QAbstractTextDocumentLayout::PaintContext).name());
    PySide::initQtMetaType< ::QAbstractTextDocumentLayout::PaintContext >();
}

