/*
 * This file is part of PySide: Python for Qt
 *
 * Copyright (C) 2009-2010 Nokia Corporation and/or its subsidiary(-ies).
 *
 * Contact: PySide team <contact@pyside.org>
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public License
 * version 2.1 as published by the Free Software Foundation.
 *
 * This library is distributed in the hope that it will be useful, but
 * WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU
 * Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public
 * License along with this library; if not, write to the Free Software
 * Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA
 * 02110-1301 USA
 *
 */


//workaround to access protected functions
#define protected public

// default includes
#include <shiboken.h>
#include <pysidesignal.h>
#include <pysideproperty.h>
#include <pyside.h>
#include <typeresolver.h>
#include <typeinfo>
#include "pyside_qtgui_python.h"

#include "qstyleoptiontabbarbase_wrapper.h"

// Extra includes
#include <qstyleoption.h>
#include <qwidget.h>



// Target ---------------------------------------------------------

extern "C" {
static int
Sbk_QStyleOptionTabBarBase_Init(PyObject* self, PyObject* args, PyObject* kwds)
{
    if (Shiboken::Object::isUserType(self) && !Shiboken::ObjectType::canCallConstructor(self->ob_type, Shiboken::SbkType<QStyleOptionTabBarBase >()))
        return -1;

    QStyleOptionTabBarBase* cptr = 0;
    int overloadId = -1;
    SbkObject* sbkSelf = reinterpret_cast<SbkObject*>(self);


    int numArgs = PyTuple_GET_SIZE(args);
    PyObject* pyargs[] = {0};

    // invalid argument lengths


    if (!PyArg_UnpackTuple(args, "QStyleOptionTabBarBase", 0, 1, &(pyargs[0])))
        return -1;

    // Overloaded function decisor
    // 0: QStyleOptionTabBarBase()
    // 1: QStyleOptionTabBarBase(QStyleOptionTabBarBase)
    // 2: QStyleOptionTabBarBase(int)
    if (numArgs == 0) {
        overloadId = 0; // QStyleOptionTabBarBase()
    } else if (numArgs == 1 && SbkNumber_Check(pyargs[0])) {
        overloadId = 2; // QStyleOptionTabBarBase(int)
    } else if (numArgs == 1 && Shiboken::Converter< ::QStyleOptionTabBarBase >::isConvertible(pyargs[0])) {
        overloadId = 1; // QStyleOptionTabBarBase(QStyleOptionTabBarBase)
    }

    // Function signature not found.
    if (overloadId == -1) goto Sbk_QStyleOptionTabBarBase_Init_TypeError;

    // Call function/method
    {
        switch (overloadId) {
            case 0: // QStyleOptionTabBarBase()
            {

                if(!PyErr_Occurred()) {
                    // QStyleOptionTabBarBase()
                    PyThreadState* _save = PyEval_SaveThread(); // Py_BEGIN_ALLOW_THREADS
                    cptr = new QStyleOptionTabBarBase();
                    PyEval_RestoreThread(_save); // Py_END_ALLOW_THREADS
                }
                break;
            }
            case 1: // QStyleOptionTabBarBase(QStyleOptionTabBarBase)
            {
                if (!Shiboken::Object::isValid(pyargs[0]))
                    return -1;
                QStyleOptionTabBarBase cppArg0 = Shiboken::Converter<QStyleOptionTabBarBase >::toCpp(pyargs[0]);

                if(!PyErr_Occurred()) {
                    // QStyleOptionTabBarBase(QStyleOptionTabBarBase)
                    PyThreadState* _save = PyEval_SaveThread(); // Py_BEGIN_ALLOW_THREADS
                    cptr = new QStyleOptionTabBarBase(cppArg0);
                    PyEval_RestoreThread(_save); // Py_END_ALLOW_THREADS
                }
                break;
            }
            case 2: // QStyleOptionTabBarBase(int)
            {
                int cppArg0 = Shiboken::Converter<int >::toCpp(pyargs[0]);

                if(!PyErr_Occurred()) {
                    // QStyleOptionTabBarBase(int)
                    PyThreadState* _save = PyEval_SaveThread(); // Py_BEGIN_ALLOW_THREADS
                    cptr = new QStyleOptionTabBarBase(cppArg0);
                    PyEval_RestoreThread(_save); // Py_END_ALLOW_THREADS
                }
                break;
            }
        }
    }

    if (PyErr_Occurred() || !Shiboken::Object::setCppPointer(sbkSelf, Shiboken::SbkType<QStyleOptionTabBarBase >(), cptr)) {
        delete cptr;
        return -1;
    }
    if (!cptr) goto Sbk_QStyleOptionTabBarBase_Init_TypeError;

    Shiboken::Object::setValidCpp(sbkSelf, true);
    Shiboken::BindingManager::instance().registerWrapper(sbkSelf, cptr);


    return 1;

    Sbk_QStyleOptionTabBarBase_Init_TypeError:
        const char* overloads[] = {"", "PySide.QtGui.QStyleOptionTabBarBase", "int", 0};
        Shiboken::setErrorAboutWrongArguments(args, "PySide.QtGui.QStyleOptionTabBarBase", overloads);
        return -1;
}

static PyObject *Sbk_QStyleOptionTabBarBase___copy__(PyObject *self)
{
        QStyleOptionTabBarBase* cppSelf = 0;
        if (!Shiboken::Object::isValid(self))
            return 0;
        cppSelf = Shiboken::Converter<QStyleOptionTabBarBase*>::toCpp(self);
        PyObject* pyResult = 0;
        QStyleOptionTabBarBase* copy = new QStyleOptionTabBarBase(*cppSelf);
        pyResult = Shiboken::Converter<QStyleOptionTabBarBase*>::toPython(copy);
        Shiboken::Object::getOwnership(pyResult);

        if (PyErr_Occurred() || !pyResult) {
            Py_XDECREF(pyResult);
            return 0;
        }
        return pyResult;
}

static PyMethodDef Sbk_QStyleOptionTabBarBase_methods[] = {

    {"__copy__", (PyCFunction)Sbk_QStyleOptionTabBarBase___copy__, METH_NOARGS},
    {0} // Sentinel
};

static PyObject* Sbk_QStyleOptionTabBarBase_get_selectedTabRect(PyObject* self, void*)
{
    PyObject* val = Shiboken::createWrapper(&Shiboken::Converter< QStyleOptionTabBarBase* >::toCpp(self)->selectedTabRect);
    Shiboken::Object::releaseOwnership(val);
    return val;
}

static int Sbk_QStyleOptionTabBarBase_set_selectedTabRect(PyObject* self, PyObject* value, void*)
{
    if (value == 0) {
        PyErr_SetString(PyExc_TypeError, "'selectedTabRect' may not be deleted");
        return -1;
    }
    if (!Shiboken::Converter< ::QRect >::isConvertible(value)) {
        PyErr_SetString(PyExc_TypeError, "wrong type attributed to 'selectedTabRect', 'QRect' or convertible type expected");
        return -1;
    }

    Shiboken::Converter< QStyleOptionTabBarBase* >::toCpp(self)->selectedTabRect = Shiboken::Converter< ::QRect >::toCpp(value);

    return 0;
}

static PyObject* Sbk_QStyleOptionTabBarBase_get_shape(PyObject* self, void*)
{
    PyObject* val = Shiboken::Converter< ::QTabBar::Shape >::toPython( Shiboken::Converter< QStyleOptionTabBarBase* >::toCpp(self)->shape);
    return val;
}

static int Sbk_QStyleOptionTabBarBase_set_shape(PyObject* self, PyObject* value, void*)
{
    if (value == 0) {
        PyErr_SetString(PyExc_TypeError, "'shape' may not be deleted");
        return -1;
    }
    if (!Shiboken::Converter< ::QTabBar::Shape >::isConvertible(value)) {
        PyErr_SetString(PyExc_TypeError, "wrong type attributed to 'shape', 'Shape' or convertible type expected");
        return -1;
    }

    Shiboken::Converter< QStyleOptionTabBarBase* >::toCpp(self)->shape = Shiboken::Converter< ::QTabBar::Shape >::toCpp(value);

    return 0;
}

static PyObject* Sbk_QStyleOptionTabBarBase_get_tabBarRect(PyObject* self, void*)
{
    PyObject* val = Shiboken::createWrapper(&Shiboken::Converter< QStyleOptionTabBarBase* >::toCpp(self)->tabBarRect);
    Shiboken::Object::releaseOwnership(val);
    return val;
}

static int Sbk_QStyleOptionTabBarBase_set_tabBarRect(PyObject* self, PyObject* value, void*)
{
    if (value == 0) {
        PyErr_SetString(PyExc_TypeError, "'tabBarRect' may not be deleted");
        return -1;
    }
    if (!Shiboken::Converter< ::QRect >::isConvertible(value)) {
        PyErr_SetString(PyExc_TypeError, "wrong type attributed to 'tabBarRect', 'QRect' or convertible type expected");
        return -1;
    }

    Shiboken::Converter< QStyleOptionTabBarBase* >::toCpp(self)->tabBarRect = Shiboken::Converter< ::QRect >::toCpp(value);

    return 0;
}

// Getters and Setters for QStyleOptionTabBarBase
static PyGetSetDef Sbk_QStyleOptionTabBarBase_getsetlist[] = {
    {const_cast<char*>("selectedTabRect"), Sbk_QStyleOptionTabBarBase_get_selectedTabRect, Sbk_QStyleOptionTabBarBase_set_selectedTabRect},
    {const_cast<char*>("shape"), Sbk_QStyleOptionTabBarBase_get_shape, Sbk_QStyleOptionTabBarBase_set_shape},
    {const_cast<char*>("tabBarRect"), Sbk_QStyleOptionTabBarBase_get_tabBarRect, Sbk_QStyleOptionTabBarBase_set_tabBarRect},
    {0}  // Sentinel
};

} // extern "C"

// Class Definition -----------------------------------------------
extern "C" {
static SbkObjectType Sbk_QStyleOptionTabBarBase_Type = { { {
    PyObject_HEAD_INIT(&SbkObjectType_Type)
    /*ob_size*/             0,
    /*tp_name*/             "PySide.QtGui.QStyleOptionTabBarBase",
    /*tp_basicsize*/        sizeof(SbkObject),
    /*tp_itemsize*/         0,
    /*tp_dealloc*/          &SbkDeallocWrapper,
    /*tp_print*/            0,
    /*tp_getattr*/          0,
    /*tp_setattr*/          0,
    /*tp_compare*/          0,
    /*tp_repr*/             0,
    /*tp_as_number*/        0,
    /*tp_as_sequence*/      0,
    /*tp_as_mapping*/       0,
    /*tp_hash*/             0,
    /*tp_call*/             0,
    /*tp_str*/              0,
    /*tp_getattro*/         0,
    /*tp_setattro*/         0,
    /*tp_as_buffer*/        0,
    /*tp_flags*/            Py_TPFLAGS_DEFAULT|Py_TPFLAGS_BASETYPE|Py_TPFLAGS_CHECKTYPES,
    /*tp_doc*/              0,
    /*tp_traverse*/         0,
    /*tp_clear*/            0,
    /*tp_richcompare*/      0,
    /*tp_weaklistoffset*/   0,
    /*tp_iter*/             0,
    /*tp_iternext*/         0,
    /*tp_methods*/          Sbk_QStyleOptionTabBarBase_methods,
    /*tp_members*/          0,
    /*tp_getset*/           Sbk_QStyleOptionTabBarBase_getsetlist,
    /*tp_base*/             0,
    /*tp_dict*/             0,
    /*tp_descr_get*/        0,
    /*tp_descr_set*/        0,
    /*tp_dictoffset*/       0,
    /*tp_init*/             Sbk_QStyleOptionTabBarBase_Init,
    /*tp_alloc*/            0,
    /*tp_new*/              SbkObjectTpNew,
    /*tp_free*/             0,
    /*tp_is_gc*/            0,
    /*tp_bases*/            0,
    /*tp_mro*/              0,
    /*tp_cache*/            0,
    /*tp_subclasses*/       0,
    /*tp_weaklist*/         0
}, },
    /*priv_data*/           0
};
} //extern


void init_QStyleOptionTabBarBase(PyObject* module)
{
    SbkPySide_QtGuiTypes[SBK_QSTYLEOPTIONTABBARBASE_IDX] = reinterpret_cast<PyTypeObject*>(&Sbk_QStyleOptionTabBarBase_Type);

    Shiboken::ObjectType::initPrivateData(&Sbk_QStyleOptionTabBarBase_Type);
    Sbk_QStyleOptionTabBarBase_Type.super.ht_type.tp_base = SbkPySide_QtGuiTypes[SBK_QSTYLEOPTION_IDX];
    Shiboken::ObjectType::setDestructorFunction(&Sbk_QStyleOptionTabBarBase_Type, &Shiboken::callCppDestructor<QStyleOptionTabBarBase >);
    if (PyType_Ready((PyTypeObject*)&Sbk_QStyleOptionTabBarBase_Type) < 0)
        return;

    Shiboken::ObjectType::setOriginalName(&Sbk_QStyleOptionTabBarBase_Type, "QStyleOptionTabBarBase");
    PyModule_AddObject(module, "QStyleOptionTabBarBase",
        ((PyObject*)&Sbk_QStyleOptionTabBarBase_Type));

    // Initialize enums
    PyObject* enumItem;

    // init enum: StyleOptionVersion
    PyTypeObject* SbkPySide_QtGui_QStyleOptionTabBarBase_StyleOptionVersion = Shiboken::Enum::newType("PySide.QtGui.QStyleOptionTabBarBase.StyleOptionVersion");
    SbkPySide_QtGuiTypes[SBK_QSTYLEOPTIONTABBARBASE_STYLEOPTIONVERSION_IDX] = SbkPySide_QtGui_QStyleOptionTabBarBase_StyleOptionVersion;
    if (PyType_Ready(SbkPySide_QtGui_QStyleOptionTabBarBase_StyleOptionVersion) < 0)
        return;
    PyDict_SetItemString(Sbk_QStyleOptionTabBarBase_Type.super.ht_type.tp_dict,
            "StyleOptionVersion",((PyObject*)SbkPySide_QtGui_QStyleOptionTabBarBase_StyleOptionVersion));

    enumItem = Shiboken::Enum::newItem(SbkPySide_QtGui_QStyleOptionTabBarBase_StyleOptionVersion,(long) QStyleOptionTabBarBase::Version, "Version");
    PyDict_SetItemString(Sbk_QStyleOptionTabBarBase_Type.super.ht_type.tp_dict,"Version", enumItem);
    Py_DECREF(enumItem);
    PyDict_SetItemString(SbkPySide_QtGui_QStyleOptionTabBarBase_StyleOptionVersion->tp_dict,"Version", enumItem);
    Py_DECREF(enumItem);
    Shiboken::TypeResolver::createValueTypeResolver<int>("QStyleOptionTabBarBase::StyleOptionVersion");
    Shiboken::TypeResolver::createValueTypeResolver<int>("::StyleOptionVersion");
    // end of enum StyleOptionVersion

    // init enum: StyleOptionType
    PyTypeObject* SbkPySide_QtGui_QStyleOptionTabBarBase_StyleOptionType = Shiboken::Enum::newType("PySide.QtGui.QStyleOptionTabBarBase.StyleOptionType");
    SbkPySide_QtGuiTypes[SBK_QSTYLEOPTIONTABBARBASE_STYLEOPTIONTYPE_IDX] = SbkPySide_QtGui_QStyleOptionTabBarBase_StyleOptionType;
    if (PyType_Ready(SbkPySide_QtGui_QStyleOptionTabBarBase_StyleOptionType) < 0)
        return;
    PyDict_SetItemString(Sbk_QStyleOptionTabBarBase_Type.super.ht_type.tp_dict,
            "StyleOptionType",((PyObject*)SbkPySide_QtGui_QStyleOptionTabBarBase_StyleOptionType));

    enumItem = Shiboken::Enum::newItem(SbkPySide_QtGui_QStyleOptionTabBarBase_StyleOptionType,(long) QStyleOptionTabBarBase::Type, "Type");
    PyDict_SetItemString(Sbk_QStyleOptionTabBarBase_Type.super.ht_type.tp_dict,"Type", enumItem);
    Py_DECREF(enumItem);
    PyDict_SetItemString(SbkPySide_QtGui_QStyleOptionTabBarBase_StyleOptionType->tp_dict,"Type", enumItem);
    Py_DECREF(enumItem);
    Shiboken::TypeResolver::createValueTypeResolver<int>("QStyleOptionTabBarBase::StyleOptionType");
    Shiboken::TypeResolver::createValueTypeResolver<int>("::StyleOptionType");
    // end of enum StyleOptionType


    Shiboken::TypeResolver::createValueTypeResolver<QStyleOptionTabBarBase >("QStyleOptionTabBarBase");
    Shiboken::TypeResolver::createObjectTypeResolver<QStyleOptionTabBarBase >("QStyleOptionTabBarBase*");
    Shiboken::TypeResolver::createValueTypeResolver<QStyleOptionTabBarBase >(typeid(QStyleOptionTabBarBase).name());
    PySide::initQtMetaType< ::QStyleOptionTabBarBase >();
    qRegisterMetaType< ::QStyleOptionTabBarBase::StyleOptionVersion >("QStyleOptionTabBarBase::StyleOptionVersion");
    qRegisterMetaType< ::QStyleOptionTabBarBase::StyleOptionType >("QStyleOptionTabBarBase::StyleOptionType");
}

