/*
 * This file is part of PySide: Python for Qt
 *
 * Copyright (C) 2009-2010 Nokia Corporation and/or its subsidiary(-ies).
 *
 * Contact: PySide team <contact@pyside.org>
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public License
 * version 2.1 as published by the Free Software Foundation.
 *
 * This library is distributed in the hope that it will be useful, but
 * WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU
 * Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public
 * License along with this library; if not, write to the Free Software
 * Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA
 * 02110-1301 USA
 *
 */


//workaround to access protected functions
#define protected public

// default includes
#include <shiboken.h>
#include <pysidesignal.h>
#include <pysideproperty.h>
#include <pyside.h>
#include <typeresolver.h>
#include <typeinfo>
#include "pyside_qtgui_python.h"

#include "qstyleoptiontabv2_wrapper.h"

// Extra includes
#include <qstyleoption.h>
#include <qwidget.h>



// Target ---------------------------------------------------------

extern "C" {
static int
Sbk_QStyleOptionTabV2_Init(PyObject* self, PyObject* args, PyObject* kwds)
{
    if (Shiboken::Object::isUserType(self) && !Shiboken::ObjectType::canCallConstructor(self->ob_type, Shiboken::SbkType<QStyleOptionTabV2 >()))
        return -1;

    QStyleOptionTabV2* cptr = 0;
    int overloadId = -1;
    SbkObject* sbkSelf = reinterpret_cast<SbkObject*>(self);


    int numArgs = PyTuple_GET_SIZE(args);
    PyObject* pyargs[] = {0};

    // invalid argument lengths


    if (!PyArg_UnpackTuple(args, "QStyleOptionTabV2", 0, 1, &(pyargs[0])))
        return -1;

    // Overloaded function decisor
    // 0: QStyleOptionTabV2()
    // 1: QStyleOptionTabV2(QStyleOptionTab)
    // 2: QStyleOptionTabV2(QStyleOptionTabV2)
    // 3: QStyleOptionTabV2(int)
    if (numArgs == 0) {
        overloadId = 0; // QStyleOptionTabV2()
    } else if (numArgs == 1 && SbkNumber_Check(pyargs[0])) {
        overloadId = 3; // QStyleOptionTabV2(int)
    } else if (numArgs == 1 && Shiboken::Converter< ::QStyleOptionTabV2 >::isConvertible(pyargs[0])) {
        overloadId = 2; // QStyleOptionTabV2(QStyleOptionTabV2)
    } else if (numArgs == 1 && Shiboken::Converter< ::QStyleOptionTab >::isConvertible(pyargs[0])) {
        overloadId = 1; // QStyleOptionTabV2(QStyleOptionTab)
    }

    // Function signature not found.
    if (overloadId == -1) goto Sbk_QStyleOptionTabV2_Init_TypeError;

    // Call function/method
    {
        switch (overloadId) {
            case 0: // QStyleOptionTabV2()
            {

                if(!PyErr_Occurred()) {
                    // QStyleOptionTabV2()
                    PyThreadState* _save = PyEval_SaveThread(); // Py_BEGIN_ALLOW_THREADS
                    cptr = new QStyleOptionTabV2();
                    PyEval_RestoreThread(_save); // Py_END_ALLOW_THREADS
                }
                break;
            }
            case 1: // QStyleOptionTabV2(QStyleOptionTab)
            {
                if (!Shiboken::Object::isValid(pyargs[0]))
                    return -1;
                QStyleOptionTab cppArg0 = Shiboken::Converter<QStyleOptionTab >::toCpp(pyargs[0]);

                if(!PyErr_Occurred()) {
                    // QStyleOptionTabV2(QStyleOptionTab)
                    PyThreadState* _save = PyEval_SaveThread(); // Py_BEGIN_ALLOW_THREADS
                    cptr = new QStyleOptionTabV2(cppArg0);
                    PyEval_RestoreThread(_save); // Py_END_ALLOW_THREADS
                }
                break;
            }
            case 2: // QStyleOptionTabV2(QStyleOptionTabV2)
            {
                if (!Shiboken::Object::isValid(pyargs[0]))
                    return -1;
                QStyleOptionTabV2 cppArg0 = Shiboken::Converter<QStyleOptionTabV2 >::toCpp(pyargs[0]);

                if(!PyErr_Occurred()) {
                    // QStyleOptionTabV2(QStyleOptionTabV2)
                    PyThreadState* _save = PyEval_SaveThread(); // Py_BEGIN_ALLOW_THREADS
                    cptr = new QStyleOptionTabV2(cppArg0);
                    PyEval_RestoreThread(_save); // Py_END_ALLOW_THREADS
                }
                break;
            }
            case 3: // QStyleOptionTabV2(int)
            {
                int cppArg0 = Shiboken::Converter<int >::toCpp(pyargs[0]);

                if(!PyErr_Occurred()) {
                    // QStyleOptionTabV2(int)
                    PyThreadState* _save = PyEval_SaveThread(); // Py_BEGIN_ALLOW_THREADS
                    cptr = new QStyleOptionTabV2(cppArg0);
                    PyEval_RestoreThread(_save); // Py_END_ALLOW_THREADS
                }
                break;
            }
        }
    }

    if (PyErr_Occurred() || !Shiboken::Object::setCppPointer(sbkSelf, Shiboken::SbkType<QStyleOptionTabV2 >(), cptr)) {
        delete cptr;
        return -1;
    }
    if (!cptr) goto Sbk_QStyleOptionTabV2_Init_TypeError;

    Shiboken::Object::setValidCpp(sbkSelf, true);
    Shiboken::BindingManager::instance().registerWrapper(sbkSelf, cptr);


    return 1;

    Sbk_QStyleOptionTabV2_Init_TypeError:
        const char* overloads[] = {"", "PySide.QtGui.QStyleOptionTab", "PySide.QtGui.QStyleOptionTabV2", "int", 0};
        Shiboken::setErrorAboutWrongArguments(args, "PySide.QtGui.QStyleOptionTabV2", overloads);
        return -1;
}

static PyObject *Sbk_QStyleOptionTabV2___copy__(PyObject *self)
{
        QStyleOptionTabV2* cppSelf = 0;
        if (!Shiboken::Object::isValid(self))
            return 0;
        cppSelf = Shiboken::Converter<QStyleOptionTabV2*>::toCpp(self);
        PyObject* pyResult = 0;
        QStyleOptionTabV2* copy = new QStyleOptionTabV2(*cppSelf);
        pyResult = Shiboken::Converter<QStyleOptionTabV2*>::toPython(copy);
        Shiboken::Object::getOwnership(pyResult);

        if (PyErr_Occurred() || !pyResult) {
            Py_XDECREF(pyResult);
            return 0;
        }
        return pyResult;
}

static PyMethodDef Sbk_QStyleOptionTabV2_methods[] = {

    {"__copy__", (PyCFunction)Sbk_QStyleOptionTabV2___copy__, METH_NOARGS},
    {0} // Sentinel
};

static PyObject* Sbk_QStyleOptionTabV2_get_iconSize(PyObject* self, void*)
{
    PyObject* val = Shiboken::createWrapper(&Shiboken::Converter< QStyleOptionTabV2* >::toCpp(self)->iconSize);
    Shiboken::Object::releaseOwnership(val);
    return val;
}

static int Sbk_QStyleOptionTabV2_set_iconSize(PyObject* self, PyObject* value, void*)
{
    if (value == 0) {
        PyErr_SetString(PyExc_TypeError, "'iconSize' may not be deleted");
        return -1;
    }
    if (!Shiboken::Converter< ::QSize >::isConvertible(value)) {
        PyErr_SetString(PyExc_TypeError, "wrong type attributed to 'iconSize', 'QSize' or convertible type expected");
        return -1;
    }

    Shiboken::Converter< QStyleOptionTabV2* >::toCpp(self)->iconSize = Shiboken::Converter< ::QSize >::toCpp(value);

    return 0;
}

// Getters and Setters for QStyleOptionTabV2
static PyGetSetDef Sbk_QStyleOptionTabV2_getsetlist[] = {
    {const_cast<char*>("iconSize"), Sbk_QStyleOptionTabV2_get_iconSize, Sbk_QStyleOptionTabV2_set_iconSize},
    {0}  // Sentinel
};

} // extern "C"

// Class Definition -----------------------------------------------
extern "C" {
static SbkObjectType Sbk_QStyleOptionTabV2_Type = { { {
    PyObject_HEAD_INIT(&SbkObjectType_Type)
    /*ob_size*/             0,
    /*tp_name*/             "PySide.QtGui.QStyleOptionTabV2",
    /*tp_basicsize*/        sizeof(SbkObject),
    /*tp_itemsize*/         0,
    /*tp_dealloc*/          &SbkDeallocWrapper,
    /*tp_print*/            0,
    /*tp_getattr*/          0,
    /*tp_setattr*/          0,
    /*tp_compare*/          0,
    /*tp_repr*/             0,
    /*tp_as_number*/        0,
    /*tp_as_sequence*/      0,
    /*tp_as_mapping*/       0,
    /*tp_hash*/             0,
    /*tp_call*/             0,
    /*tp_str*/              0,
    /*tp_getattro*/         0,
    /*tp_setattro*/         0,
    /*tp_as_buffer*/        0,
    /*tp_flags*/            Py_TPFLAGS_DEFAULT|Py_TPFLAGS_BASETYPE|Py_TPFLAGS_CHECKTYPES,
    /*tp_doc*/              0,
    /*tp_traverse*/         0,
    /*tp_clear*/            0,
    /*tp_richcompare*/      0,
    /*tp_weaklistoffset*/   0,
    /*tp_iter*/             0,
    /*tp_iternext*/         0,
    /*tp_methods*/          Sbk_QStyleOptionTabV2_methods,
    /*tp_members*/          0,
    /*tp_getset*/           Sbk_QStyleOptionTabV2_getsetlist,
    /*tp_base*/             0,
    /*tp_dict*/             0,
    /*tp_descr_get*/        0,
    /*tp_descr_set*/        0,
    /*tp_dictoffset*/       0,
    /*tp_init*/             Sbk_QStyleOptionTabV2_Init,
    /*tp_alloc*/            0,
    /*tp_new*/              SbkObjectTpNew,
    /*tp_free*/             0,
    /*tp_is_gc*/            0,
    /*tp_bases*/            0,
    /*tp_mro*/              0,
    /*tp_cache*/            0,
    /*tp_subclasses*/       0,
    /*tp_weaklist*/         0
}, },
    /*priv_data*/           0
};
} //extern


void init_QStyleOptionTabV2(PyObject* module)
{
    SbkPySide_QtGuiTypes[SBK_QSTYLEOPTIONTABV2_IDX] = reinterpret_cast<PyTypeObject*>(&Sbk_QStyleOptionTabV2_Type);

    Shiboken::ObjectType::initPrivateData(&Sbk_QStyleOptionTabV2_Type);
    Sbk_QStyleOptionTabV2_Type.super.ht_type.tp_base = SbkPySide_QtGuiTypes[SBK_QSTYLEOPTIONTAB_IDX];
    Shiboken::ObjectType::setDestructorFunction(&Sbk_QStyleOptionTabV2_Type, &Shiboken::callCppDestructor<QStyleOptionTabV2 >);
    if (PyType_Ready((PyTypeObject*)&Sbk_QStyleOptionTabV2_Type) < 0)
        return;

    Shiboken::ObjectType::setOriginalName(&Sbk_QStyleOptionTabV2_Type, "QStyleOptionTabV2");
    PyModule_AddObject(module, "QStyleOptionTabV2",
        ((PyObject*)&Sbk_QStyleOptionTabV2_Type));

    // Initialize enums
    PyObject* enumItem;

    // init enum: StyleOptionVersion
    PyTypeObject* SbkPySide_QtGui_QStyleOptionTabV2_StyleOptionVersion = Shiboken::Enum::newType("PySide.QtGui.QStyleOptionTabV2.StyleOptionVersion");
    SbkPySide_QtGuiTypes[SBK_QSTYLEOPTIONTABV2_STYLEOPTIONVERSION_IDX] = SbkPySide_QtGui_QStyleOptionTabV2_StyleOptionVersion;
    if (PyType_Ready(SbkPySide_QtGui_QStyleOptionTabV2_StyleOptionVersion) < 0)
        return;
    PyDict_SetItemString(Sbk_QStyleOptionTabV2_Type.super.ht_type.tp_dict,
            "StyleOptionVersion",((PyObject*)SbkPySide_QtGui_QStyleOptionTabV2_StyleOptionVersion));

    enumItem = Shiboken::Enum::newItem(SbkPySide_QtGui_QStyleOptionTabV2_StyleOptionVersion,(long) QStyleOptionTabV2::Version, "Version");
    PyDict_SetItemString(Sbk_QStyleOptionTabV2_Type.super.ht_type.tp_dict,"Version", enumItem);
    Py_DECREF(enumItem);
    PyDict_SetItemString(SbkPySide_QtGui_QStyleOptionTabV2_StyleOptionVersion->tp_dict,"Version", enumItem);
    Py_DECREF(enumItem);
    Shiboken::TypeResolver::createValueTypeResolver<int>("QStyleOptionTabV2::StyleOptionVersion");
    Shiboken::TypeResolver::createValueTypeResolver<int>("::StyleOptionVersion");
    // end of enum StyleOptionVersion


    Shiboken::TypeResolver::createValueTypeResolver<QStyleOptionTabV2 >("QStyleOptionTabV2");
    Shiboken::TypeResolver::createObjectTypeResolver<QStyleOptionTabV2 >("QStyleOptionTabV2*");
    Shiboken::TypeResolver::createValueTypeResolver<QStyleOptionTabV2 >(typeid(QStyleOptionTabV2).name());
    PySide::initQtMetaType< ::QStyleOptionTabV2 >();
    qRegisterMetaType< ::QStyleOptionTabV2::StyleOptionVersion >("QStyleOptionTabV2::StyleOptionVersion");
}

