/*
 * This file is part of PySide: Python for Qt
 *
 * Copyright (C) 2009-2010 Nokia Corporation and/or its subsidiary(-ies).
 *
 * Contact: PySide team <contact@pyside.org>
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public License
 * version 2.1 as published by the Free Software Foundation.
 *
 * This library is distributed in the hope that it will be useful, but
 * WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU
 * Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public
 * License along with this library; if not, write to the Free Software
 * Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA
 * 02110-1301 USA
 *
 */


//workaround to access protected functions
#define protected public

// default includes
#include <shiboken.h>
#include <pysidesignal.h>
#include <pysideproperty.h>
#include <pyside.h>
#include <typeresolver.h>
#include <typeinfo>
#include "pyside_qtwebkit_python.h"

#include "qwebpage_choosemultiplefilesextensionreturn_wrapper.h"

// Extra includes



// Target ---------------------------------------------------------

extern "C" {
static int
Sbk_QWebPage_ChooseMultipleFilesExtensionReturn_Init(PyObject* self, PyObject* args, PyObject* kwds)
{
    if (Shiboken::Object::isUserType(self) && !Shiboken::ObjectType::canCallConstructor(self->ob_type, Shiboken::SbkType<QWebPage::ChooseMultipleFilesExtensionReturn >()))
        return -1;

    QWebPage::ChooseMultipleFilesExtensionReturn* cptr = 0;
    int overloadId = -1;
    SbkObject* sbkSelf = reinterpret_cast<SbkObject*>(self);


    int numArgs = PyTuple_GET_SIZE(args);
    PyObject* pyargs[] = {0};

    // invalid argument lengths


    if (!PyArg_UnpackTuple(args, "ChooseMultipleFilesExtensionReturn", 0, 1, &(pyargs[0])))
        return -1;

    // Overloaded function decisor
    // 0: ChooseMultipleFilesExtensionReturn()
    // 1: ChooseMultipleFilesExtensionReturn(QWebPage::ChooseMultipleFilesExtensionReturn)
    if (numArgs == 0) {
        overloadId = 0; // ChooseMultipleFilesExtensionReturn()
    } else if (numArgs == 1 && Shiboken::Converter< ::QWebPage::ChooseMultipleFilesExtensionReturn >::isConvertible(pyargs[0])) {
        overloadId = 1; // ChooseMultipleFilesExtensionReturn(QWebPage::ChooseMultipleFilesExtensionReturn)
    }

    // Function signature not found.
    if (overloadId == -1) goto Sbk_QWebPage_ChooseMultipleFilesExtensionReturn_Init_TypeError;

    // Call function/method
    {
        switch (overloadId) {
            case 0: // ChooseMultipleFilesExtensionReturn()
            {

                if(!PyErr_Occurred()) {
                    // ChooseMultipleFilesExtensionReturn()
                    PyThreadState* _save = PyEval_SaveThread(); // Py_BEGIN_ALLOW_THREADS
                    cptr = new QWebPage::ChooseMultipleFilesExtensionReturn();
                    PyEval_RestoreThread(_save); // Py_END_ALLOW_THREADS
                }
                break;
            }
            case 1: // ChooseMultipleFilesExtensionReturn(QWebPage::ChooseMultipleFilesExtensionReturn)
            {
                if (!Shiboken::Object::isValid(pyargs[0]))
                    return -1;
                QWebPage::ChooseMultipleFilesExtensionReturn cppArg0 = Shiboken::Converter<QWebPage::ChooseMultipleFilesExtensionReturn >::toCpp(pyargs[0]);

                if(!PyErr_Occurred()) {
                    // ChooseMultipleFilesExtensionReturn(QWebPage::ChooseMultipleFilesExtensionReturn)
                    PyThreadState* _save = PyEval_SaveThread(); // Py_BEGIN_ALLOW_THREADS
                    cptr = new QWebPage::ChooseMultipleFilesExtensionReturn(cppArg0);
                    PyEval_RestoreThread(_save); // Py_END_ALLOW_THREADS
                }
                break;
            }
        }
    }

    if (PyErr_Occurred() || !Shiboken::Object::setCppPointer(sbkSelf, Shiboken::SbkType<QWebPage::ChooseMultipleFilesExtensionReturn >(), cptr)) {
        delete cptr;
        return -1;
    }
    if (!cptr) goto Sbk_QWebPage_ChooseMultipleFilesExtensionReturn_Init_TypeError;

    Shiboken::Object::setValidCpp(sbkSelf, true);
    Shiboken::BindingManager::instance().registerWrapper(sbkSelf, cptr);


    return 1;

    Sbk_QWebPage_ChooseMultipleFilesExtensionReturn_Init_TypeError:
        const char* overloads[] = {"", "PySide.QtWebKit.QWebPage::ChooseMultipleFilesExtensionReturn", 0};
        Shiboken::setErrorAboutWrongArguments(args, "PySide.QtWebKit.ChooseMultipleFilesExtensionReturn", overloads);
        return -1;
}

static PyObject *Sbk_QWebPage_ChooseMultipleFilesExtensionReturn___copy__(PyObject *self)
{
        QWebPage::ChooseMultipleFilesExtensionReturn* cppSelf = 0;
        if (!Shiboken::Object::isValid(self))
            return 0;
        cppSelf = Shiboken::Converter<QWebPage::ChooseMultipleFilesExtensionReturn*>::toCpp(self);
        PyObject* pyResult = 0;
        QWebPage::ChooseMultipleFilesExtensionReturn* copy = new QWebPage::ChooseMultipleFilesExtensionReturn(*cppSelf);
        pyResult = Shiboken::Converter<QWebPage::ChooseMultipleFilesExtensionReturn*>::toPython(copy);
        Shiboken::Object::getOwnership(pyResult);

        if (PyErr_Occurred() || !pyResult) {
            Py_XDECREF(pyResult);
            return 0;
        }
        return pyResult;
}

static PyMethodDef Sbk_QWebPage_ChooseMultipleFilesExtensionReturn_methods[] = {

    {"__copy__", (PyCFunction)Sbk_QWebPage_ChooseMultipleFilesExtensionReturn___copy__, METH_NOARGS},
    {0} // Sentinel
};

static PyObject* Sbk_QWebPage_ChooseMultipleFilesExtensionReturn_get_fileNames(PyObject* self, void*)
{
    PyObject* val = Shiboken::createWrapper(&Shiboken::Converter< QWebPage::ChooseMultipleFilesExtensionReturn* >::toCpp(self)->fileNames);
    Shiboken::Object::releaseOwnership(val);
    return val;
}

static int Sbk_QWebPage_ChooseMultipleFilesExtensionReturn_set_fileNames(PyObject* self, PyObject* value, void*)
{
    if (value == 0) {
        PyErr_SetString(PyExc_TypeError, "'fileNames' may not be deleted");
        return -1;
    }
    if (!Shiboken::Converter< ::QStringList >::isConvertible(value)) {
        PyErr_SetString(PyExc_TypeError, "wrong type attributed to 'fileNames', 'QList' or convertible type expected");
        return -1;
    }

    Shiboken::Converter< QWebPage::ChooseMultipleFilesExtensionReturn* >::toCpp(self)->fileNames = Shiboken::Converter< ::QStringList >::toCpp(value);

    return 0;
}

// Getters and Setters for ChooseMultipleFilesExtensionReturn
static PyGetSetDef Sbk_QWebPage_ChooseMultipleFilesExtensionReturn_getsetlist[] = {
    {const_cast<char*>("fileNames"), Sbk_QWebPage_ChooseMultipleFilesExtensionReturn_get_fileNames, Sbk_QWebPage_ChooseMultipleFilesExtensionReturn_set_fileNames},
    {0}  // Sentinel
};

} // extern "C"

// Class Definition -----------------------------------------------
extern "C" {
static SbkObjectType Sbk_QWebPage_ChooseMultipleFilesExtensionReturn_Type = { { {
    PyObject_HEAD_INIT(&SbkObjectType_Type)
    /*ob_size*/             0,
    /*tp_name*/             "PySide.QtWebKit.QWebPage.ChooseMultipleFilesExtensionReturn",
    /*tp_basicsize*/        sizeof(SbkObject),
    /*tp_itemsize*/         0,
    /*tp_dealloc*/          &SbkDeallocWrapper,
    /*tp_print*/            0,
    /*tp_getattr*/          0,
    /*tp_setattr*/          0,
    /*tp_compare*/          0,
    /*tp_repr*/             0,
    /*tp_as_number*/        0,
    /*tp_as_sequence*/      0,
    /*tp_as_mapping*/       0,
    /*tp_hash*/             0,
    /*tp_call*/             0,
    /*tp_str*/              0,
    /*tp_getattro*/         0,
    /*tp_setattro*/         0,
    /*tp_as_buffer*/        0,
    /*tp_flags*/            Py_TPFLAGS_DEFAULT|Py_TPFLAGS_BASETYPE|Py_TPFLAGS_CHECKTYPES,
    /*tp_doc*/              0,
    /*tp_traverse*/         0,
    /*tp_clear*/            0,
    /*tp_richcompare*/      0,
    /*tp_weaklistoffset*/   0,
    /*tp_iter*/             0,
    /*tp_iternext*/         0,
    /*tp_methods*/          Sbk_QWebPage_ChooseMultipleFilesExtensionReturn_methods,
    /*tp_members*/          0,
    /*tp_getset*/           Sbk_QWebPage_ChooseMultipleFilesExtensionReturn_getsetlist,
    /*tp_base*/             0,
    /*tp_dict*/             0,
    /*tp_descr_get*/        0,
    /*tp_descr_set*/        0,
    /*tp_dictoffset*/       0,
    /*tp_init*/             Sbk_QWebPage_ChooseMultipleFilesExtensionReturn_Init,
    /*tp_alloc*/            0,
    /*tp_new*/              SbkObjectTpNew,
    /*tp_free*/             0,
    /*tp_is_gc*/            0,
    /*tp_bases*/            0,
    /*tp_mro*/              0,
    /*tp_cache*/            0,
    /*tp_subclasses*/       0,
    /*tp_weaklist*/         0
}, },
    /*priv_data*/           0
};
} //extern


void init_QWebPage_ChooseMultipleFilesExtensionReturn(PyObject* module)
{
    SbkPySide_QtWebKitTypes[SBK_QWEBPAGE_CHOOSEMULTIPLEFILESEXTENSIONRETURN_IDX] = reinterpret_cast<PyTypeObject*>(&Sbk_QWebPage_ChooseMultipleFilesExtensionReturn_Type);

    Shiboken::ObjectType::initPrivateData(&Sbk_QWebPage_ChooseMultipleFilesExtensionReturn_Type);
    Sbk_QWebPage_ChooseMultipleFilesExtensionReturn_Type.super.ht_type.tp_base = SbkPySide_QtWebKitTypes[SBK_QWEBPAGE_EXTENSIONRETURN_IDX];
    Shiboken::ObjectType::setDestructorFunction(&Sbk_QWebPage_ChooseMultipleFilesExtensionReturn_Type, &Shiboken::callCppDestructor<QWebPage::ChooseMultipleFilesExtensionReturn >);
    if (PyType_Ready((PyTypeObject*)&Sbk_QWebPage_ChooseMultipleFilesExtensionReturn_Type) < 0)
        return;

    Shiboken::ObjectType::setOriginalName(&Sbk_QWebPage_ChooseMultipleFilesExtensionReturn_Type, "QWebPage::ChooseMultipleFilesExtensionReturn");
    PyDict_SetItemString(module,"ChooseMultipleFilesExtensionReturn", (PyObject*)&Sbk_QWebPage_ChooseMultipleFilesExtensionReturn_Type);

    Shiboken::TypeResolver::createValueTypeResolver<QWebPage::ChooseMultipleFilesExtensionReturn >("QWebPage::ChooseMultipleFilesExtensionReturn");
    Shiboken::TypeResolver::createObjectTypeResolver<QWebPage::ChooseMultipleFilesExtensionReturn >("QWebPage::ChooseMultipleFilesExtensionReturn*");
    Shiboken::TypeResolver::createValueTypeResolver<QWebPage::ChooseMultipleFilesExtensionReturn >(typeid(QWebPage::ChooseMultipleFilesExtensionReturn).name());
    PySide::initQtMetaType< ::QWebPage::ChooseMultipleFilesExtensionReturn >();
}

